Page MenuHomePhabricator

Post deploy: Move search styles into layout.less (and other places) and remove temporary feature flags
Closed, ResolvedPublic3 Estimated Story Points

Description

NOTE: This task should be taken on when max-width and search have been implemented (T249363) and deployed for at least 2 weeks across test wikis and the A/B test has completed (T265333). Current test end date: Nov 4

As part of the max-width layout work (T246420), a layout-max-width.less file was created containing all the styles relevant to the max-width work along with a VectorLayoutMaxWidth feature flag to make the deployment less risky. While the feature flag is helpful in the short-term, it has a high carrying cost [1] and will be difficult to maintain in the long-term. The max-width design should just be part of the modern Vector experience (non-configurable) and the feature flag removed as soon as possible following its deploy.

Similarly as part of T249363 a feature flag was added for the search in the header feature.

[1] https://martinfowler.com/articles/feature-toggles.html#ManagingTheCarryingCostOfFeatureToggles

Developer Notes

Most of these styles should be easy enough to merge into layout.less or Sidebar.less, but there are several pending questions:

  1. Should the Less variables found in layout-max-width.less be moved to layout.less or to variables.less? I think @Volker_E was of the opinion that these should be part of variables.less.
  2. Should the styles pertaining only to history and special pages be split into their own stylesheet and conditionally loaded or be part of layout.less (where they load on every page)?
  3. Should the breakpoint media queries be moved to layout.less or is there a better place to put these?

QA steps (time sensitive)

Exploratory testing is suggested here.

Load Vector modern on https://en.wikipedia.beta.wmflabs.org/wiki/Main_Page and compare with en.wikipedia.org looking for any visual inconsistencies.

Particularly check at different resolutions.

(Note that it's expected that the version on the beta cluster renders better on smaller screens)

Developer sign off

  • VectorLayoutMaxWidth config flag is removed.
  • VectorIsSearchInHeader config flag is removed.
  • Simplify layout-max-width.less styles, moving into layout.less where applicable.
  • Fold layout-search-header.less styles into layout-default, removing and cleaning up styles where possible.
  • wmf-config is revised to remove outdated configurations.

Notes

Given the max-width is disabled on certain pages, many of the styles currently found in layout-max-width.less and the file itself will need to stay

QA Results - Beta

ACStatusDetails
1T258116#6622397

Event Timeline

Jdlrobson renamed this task from Move max-width layout styles into layout.less (and other places) and remove feature flag to Post deploy: Move search and max-width layout styles into layout.less (and other places) and remove temporary feature flags.Jul 17 2020, 5:05 PM
Jdlrobson updated the task description. (Show Details)
Jdlrobson added a subscriber: Jdlrobson.

Thanks for creating this @nray. Have expanded the scope to include search (I believe these two are very closely tied) and will move back to backlog for now. Will talk to Olga about prioritization. There is some benefit to keeping the flags until we have community acceptance but agreed about the cost of its existence.

Jdlrobson renamed this task from Post deploy: Move search and max-width layout styles into layout.less (and other places) and remove temporary feature flags to Post deploy: Move search styles into layout.less (and other places) and remove temporary feature flags.Sep 1 2020, 10:38 PM
Jdlrobson updated the task description. (Show Details)

This is blocked on the end of the A/B test in T261648. I can't analyse until that has happened.

Change 631838 had a related patch set uploaded (by Jdlrobson; owner: Jdlrobson):
[mediawiki/skins/Vector@master] Cleanup: Merge layout-search-header.less into default layout rules

https://gerrit.wikimedia.org/r/631838

This task should be pulled into the sprint immediately after the A/B test is completed. No point in this hanging out in "blocked on others"

Jdlrobson raised the priority of this task from Medium to High.Oct 9 2020, 9:27 PM

Given the train delay, this can be worked on next week. Even if the changes are merged on Monday the A/B test will have concluded, before this code has ridden the train.

This is presumably high as it blocks T264206 and T264218

Change 631214 had a related patch set uploaded (by Jdlrobson; owner: Jdlrobson):
[mediawiki/skins/Vector@master] Remove SearchInHeader requirement/feature

https://gerrit.wikimedia.org/r/631214

ovasileva set the point value for this task to 3.

Change 631214 merged by jenkins-bot:
[mediawiki/skins/Vector@master] Remove SearchInHeader requirement/feature

https://gerrit.wikimedia.org/r/631214

Change 637735 had a related patch set uploaded (by Jdlrobson; owner: Jdlrobson):
[mediawiki/skins/Vector@master] Cleanup: Merge layout-max-width.less into default layout rules

https://gerrit.wikimedia.org/r/637735

Change 631838 merged by jenkins-bot:
[mediawiki/skins/Vector@master] Cleanup: Merge layout-search-header.less into default layout rules

https://gerrit.wikimedia.org/r/631838

Change 637735 merged by jenkins-bot:
[mediawiki/skins/Vector@master] Cleanup: Merge layout-max-width.less into default layout rules

https://gerrit.wikimedia.org/r/637735

Edtadros added a subscriber: Edtadros.

Status:
Environment: beta
OS: macOS Catalina
Browser: Chrome
Device: MBP
Emulated Device: NA

Test Artifact(s):

QA Steps

Load Vector modern on https://en.wikipedia.beta.wmflabs.org/wiki/Main_Page and compare with en.wikipedia.org looking for any visual inconsistencies.

The only inconsistencies that appear are at narrow width resolutions.

  1. the Welcome to Wikipedia section doesn't wrap around in production but does in beta.
  2. The color formatting of the sections goes away at narrow width resolutions in beta.

Jdlrobson added a subscriber: sgrabarczuk.

The only inconsistencies that appear are at narrow width resolutions.

Sounds great.

The color formatting of the sections goes away at narrow width resolutions in beta.

This is intentional and a decision made by the editors so this is fine.

the Welcome to Wikipedia section doesn't wrap around in production but does in beta.

Thanks for flagging this. @sgrabarczuk not sure if we have a process here for notifying community of problems with content at lower resolutions, but this would need to be fixed in the main page via the edit button.

This can skip QA in production as there's nothing to compare with when this rolls out. Editors will let us know if there are any edge cases we may have missed.

Change 643076 had a related patch set uploaded (by Jdlrobson; owner: Jdlrobson):
[operations/mediawiki-config@master] Remove temporary feature flags

https://gerrit.wikimedia.org/r/643076

Change 643076 merged by jenkins-bot:
[operations/mediawiki-config@master] Remove temporary feature flags

https://gerrit.wikimedia.org/r/643076

Mentioned in SAL (#wikimedia-operations) [2020-11-24T19:24:39Z] <urbanecm@deploy1001> Synchronized wmf-config/InitialiseSettings.php: 331a129: Remove temporary feature flags (T258116) (duration: 00m 57s)

Jdlrobson updated the task description. (Show Details)